unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    procedure CheckBox1Change(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  IpHtml;

type
  THtmlHintWindow = class(THintWindow)
  private
    FHtmlPanel: TIpHtmlPanel;
  public
    constructor Create(AOwner: TComponent); override;
    procedure ActivateHint(ARect: TRect; const AHint: String); override;
    function CalcHintRect(MaxWidth: Integer; const AHint: String; AData: pointer): TRect; override;
  end;

{ TForm1 }

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  if Checkbox1.Checked then
    HintWindowClass := THtmlHintWindow
  else
    HintWindowClass := THintWindow;
end;

constructor THtmlHintWindow.Create(AOwner: TComponent);
begin
  inherited;
  FHtmlPanel := TIpHtmlPanel.Create(self);
  InsertControl(FHtmlPanel);
  FHtmlPanel.Align := alClient;
end;

procedure THtmlHintWindow.ActivateHint(ARect: TRect; const AHint: String);
begin
  FHtmlPanel.SetHtmlFromStr('<html>' + AHint + '</html>');
//  ARect.Right := ARect.Left + FHtmlPanel.GetContentSize.CX;
  ARect.Bottom := ARect.Top + FHtmlPanel.MasterFrame.Html.PageHeight;
  inherited ActivateHint(ARect, '');
end;

function THtmlHintWindow.CalcHintRect(MaxWidth: Integer; const AHint: String;
  AData: pointer): TRect;
begin
  Result := inherited;
  Result.Right := Result.Left + 300;
  Result.Bottom := Result.Top + 100;
end;

end.

